unit TabListEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, ToolEdit, CurrEdit, DsgnIntf, TabListBox, ExtCtrls;

type
  TListBoxRkEditor = class (TComponentEditor)
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

  TTabEditor = class(TForm)
    tbInput: TCurrencyEdit;
    tbLb: TListBox;
    Label2: TLabel;
    rbLeft: TRadioButton;
    rbRight: TRadioButton;
    rbCenter: TRadioButton;
    Label3: TLabel;
    bNastav: TButton;
    bZrus: TButton;
    bZrusAll: TButton;
    bOk: TButton;
    bStorno: TButton;
    bKrok: TButton;
    tbPozice: TLabel;
    Jednotky: TRadioGroup;
    tbKrok: TCurrencyEdit;
    procedure ButtonClick(Sender: TObject);
    procedure rbButtonClick(Sender: TObject);
    procedure tbKrokChange(Sender: TObject);
    procedure tbLbClick(Sender: TObject);
    procedure tbLbDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure bKrokClick(Sender: TObject);
    procedure JednotkyClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
    Lb:TListBoxRk;
    procedure Pozice;
    function ValueToPixel(Value:Extended):Integer;
    function PixelToValue(Value:Integer):Extended;
  public
    { Public declarations }
  end;

implementation

{$R *.DFM}

// TListBoxRkEditor

function TListBoxRkEditor.GetVerbCount: Integer;
begin
 Result:=1;
end;

function TListBoxRkEditor.GetVerb (Index: Integer): string;
begin
 Result:='Tabs...';
end;

procedure TListBoxRkEditor.ExecuteVerb (Index: Integer);
var
 i:integer;
 s:string;
begin
 with TTabEditor.Create(Application) do
 try
  Lb:=TListBoxRk(Component);
  for i:=1 to Lb.TabCount do
   if Lb.Tab[i]>Lb.Tab[i-1] then
    tbLb.Items.AddObject(IntToStr(Lb.Tab[i]),TObject(Ord(Lb.TabAlign[i])))
   else break;
  Pozice;
  if ShowModal=mrOk then
  begin
   if tbLb.Items.Count=0 then s:='0|0;'else
   begin
    s:='';
    for i:=0 to tbLb.Items.Count-1 do
    begin
     s:=s+tbLb.Items[i]+'|'+IntToStr(Longint(tbLb.Items.Objects[i]))+';';
    end;
   end;
   Lb.TabString:=s;
   if Designer<>nil then Designer.Modified;
  end;
 finally
  Free;
 end;
end;

// TTabEditor

procedure TTabEditor.FormResize(Sender: TObject);
begin
 tbLb.Invalidate;
end;

procedure TTabEditor.rbButtonClick(Sender: TObject);
begin
 if Sender=rbLeft then tbLb.Tag:=0 else
  if Sender=rbRight then tbLb.Tag:=1
  else tbLb.Tag:=2;
end;

procedure TTabEditor.ButtonClick(Sender: TObject);
var
 i:integer;
begin
 // Set
 if(Sender=bNastav)and(tbInput.Value>0)then
 begin
  i:=tbLb.Items.IndexOf(IntToStr(ValueToPixel(tbInput.Value)));
  if i=-1 then
  begin
   if tbLb.Items.Count=Lb.TabCount then
   begin
    Application.MessageBox('Count of tabs reach value of TabCount !',
      'Info',MB_ICONINFORMATION)
   end
   else
   begin
    for i:=tbLb.Items.Count-1 downto 0 do
     if ValueToPixel(tbInput.Value)>StrToInt(tbLb.Items[i]) then break;
    tbLb.Items.InsertObject(i+1,IntToStr(ValueToPixel(tbInput.Value)),TObject(tbLb.Tag));
   end;
  end
  else
  begin
   tbLb.Items.Objects[tbLb.ItemIndex]:=TObject(tbLb.Tag);
   tbLb.Invalidate;
  end;
  tbInput.Clear;
 end;
 // Clear
 if(Sender=bZrus)and(tbLb.Itemindex<>-1)then
 begin
  tbLb.Items.Delete(tbLb.Itemindex);
 end;
 // Clear All
 if Sender=bZrusAll then tbLb.Clear;
 Pozice;
end;

procedure TTabEditor.tbKrokChange(Sender: TObject);
begin
 if tbKrok.Value<0 then tbKrok.Value:=0
 else tbKrok.Tag:=ValueToPixel(tbKrok.Value);
end;

procedure TTabEditor.tbLbClick(Sender: TObject);
begin
 tbInput.Value:=PixelToValue(StrToInt(tbLb.Items[tbLb.ItemIndex]));
 case Longint(tbLb.Items.Objects[tbLb.ItemIndex])of
  0:rbLeft.Checked:=true;
  1:rbRight.Checked:=true;
  2:rbCenter.Checked:=true;
 end;
 Pozice;
end;

procedure TTabEditor.tbLbDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
 ch:char;
 s:string;
begin
 with tbLb do
 begin
  Canvas.FillRect(Rect);
  case Longint(Items.Objects[Index])of
   0:ch:='L';
   1:ch:='R';
   2:ch:='C';
  end;
  s:=FloatToStr(PixelToValue(StrToInt(Items[Index])));
  Canvas.TextOut(Rect.Left+2,Rect.Top,ch);
  Canvas.TextOut(Rect.Right-Canvas.TextWidth(s)-5,Rect.Top,s);
 end;
end;

procedure TTabEditor.bKrokClick(Sender: TObject);
var
 i:Integer;
begin
 if tbKrok.Value>0 then
 begin
  tbLb.Clear;
  for i:=1 to Lb.TabCount do
   tbLb.Items.AddObject(IntToStr(ValueToPixel(tbKrok.Value*i)),TObject(tbLb.Tag));
  Pozice;
 end;
end;

procedure TTabEditor.Pozice;
var
 i:Integer;
begin
 if(tbLb.ItemIndex=-1)and(tbLb.Items.Count>0)then i:=1
 else i:=tbLb.ItemIndex+1;
 tbPozice.Caption:=Format('Row: %d/%d (%d)',[i,tbLb.Items.Count,Lb.TabCount]);
end;

procedure TTabEditor.JednotkyClick(Sender: TObject);
begin
 tbKrok.OnChange:=nil;
 if Jednotky.ItemIndex=2 then //cm
 begin
  tbInput.DecimalPlaces:=1;
  tbInput.DisplayFormat:='#.#;#.#;#.#';
  tbKrok.DecimalPlaces:=1;
  tbKrok.DisplayFormat:=tbInput.DisplayFormat;
 end
 else // pixels,mm
 begin
  tbInput.DecimalPlaces:=0;
  tbInput.DisplayFormat:='#;#;#';
  tbKrok.DecimalPlaces:=0;
  tbKrok.DisplayFormat:=tbInput.DisplayFormat;
 end;
 tbInput.Clear;
 tbKrok.Value:=PixelToValue(tbKrok.Tag);
 tbKrok.OnChange:=tbKrokChange;
 tbLb.Invalidate;
end;

function TTabEditor.ValueToPixel(Value: Extended): Integer;
begin
 case Jednotky.ItemIndex of
  0:Result:=Trunc(Value);
  1:Result:=Lb.MmToPixel(Trunc(Value));
  2:Result:=Lb.MmToPixel(Trunc(Value*10));
 end;
end;

function TTabEditor.PixelToValue(Value: Integer): Extended;
begin
 case Jednotky.ItemIndex of
  0:Result:=Value;
  1:Result:=Lb.PixelToMm(Value);
  2:Result:=Lb.PixelToMm(Value)/10;
 end;
end;

end.
